--- a/lib/number.vala	Fri Jan 29 16:44:36 2016
+++ b/lib/number.vala	Mon Feb  1 12:02:40 2016
@@ -27,8 +27,15 @@
  *  THE MP USERS GUIDE.
  */
 
-using MPFR;
 
+/* Size of the multiple precision values */
+private const int SIZE = 1000;
+
+/* Base for numbers */
+private const int BASE = 10000;
+
+private const int T = 100;
+
 private delegate int BitwiseFunc (int v1, int v2);
 
 public enum AngleUnit
@@ -41,37 +48,69 @@
 /* Object for a high precision floating point number representation */
 public class Number : Object
 {
-    /* real and imaginary part of a Number */
-    private MPFloat re_num { get; set; }
-    private MPFloat im_num { get; set; }
+    /* Sign (+1, -1) or 0 for the value zero */
+    public int re_sign;
+    public int im_sign;
 
-    public static ulong precision { get; set; default = 1000; }
+    /* Exponent (to base BASE) */
+    public int re_exponent;
+    public int im_exponent;
 
-    /* Stores the error msg if an error occurs during calculation. Otherwise should be null */
-    public static string? error { get; set; default = null; }
+    /* Normalized fraction */
+    public int re_fraction[1000]; // SIZE
+    public int im_fraction[1000]; // SIZE
 
     public Number.integer (int64 value)
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.set_signed_integer ((long)value, Round.NEAREST);
-        re_num = tmp;
-        var tmp2 = MPFloat.init2 ((Precision) precision);
-        tmp2.set_unsigned_integer (0, Round.NEAREST);
-        im_num = tmp2;
+        if (value < 0)
+        {
+            value = -value;
+            re_sign = -1;
+        }
+        else if (value > 0)
+            re_sign = 1;
+        else
+            re_sign = 0;
+
+        while (value != 0)
+        {
+            re_fraction[re_exponent] = (int) (value % BASE);
+            re_exponent++;
+            value /= BASE;
+        }
+        for (var i = 0; i < re_exponent / 2; i++)
+        {
+            int t = re_fraction[i];
+            re_fraction[i] = re_fraction[re_exponent - i - 1];
+            re_fraction[re_exponent - i - 1] = t;
+        }
     }
 
     public Number.unsigned_integer (uint64 x)
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.set_unsigned_integer ((ulong)x, Round.NEAREST);
-        re_num = tmp;
-        var tmp2 = MPFloat.init2 ((Precision) precision);
-        tmp2.set_unsigned_integer (0, Round.NEAREST);
-        im_num = tmp2;
+        if (x == 0)
+            re_sign = 0;
+        else
+            re_sign = 1;
+
+        while (x != 0)
+        {
+            re_fraction[re_exponent] = (int) (x % BASE);
+            x = x / BASE;
+            re_exponent++;
+        }
+        for (var i = 0; i < re_exponent / 2; i++)
+        {
+            int t = re_fraction[i];
+            re_fraction[i] = re_fraction[re_exponent - i - 1];
+            re_fraction[re_exponent - i - 1] = t;
+        }
     }
 
     public Number.fraction (int64 numerator, int64 denominator)
     {
+        mp_gcd (ref numerator, ref denominator);
+
         if (denominator < 0)
         {
             numerator = -numerator;
@@ -81,39 +120,203 @@
         Number.integer (numerator);
         if (denominator != 1)
         {
-            var tmp = re_num;
-            tmp.divide_signed_integer (re_num, (long) denominator, Round.NEAREST);
-            re_num = tmp;
+            var z = divide_integer (denominator);
+            re_sign = z.re_sign;
+            im_sign = z.im_sign;
+            re_exponent = z.re_exponent;
+            im_exponent = z.im_exponent;
+            for (var i = 0; i < z.re_fraction.length; i++)
+            {
+                re_fraction[i] = z.re_fraction[i];
+                im_fraction[i] = z.im_fraction[i];
+            }
         }
     }
 
-    /* Helper constructor. Creates new Number from already existing MPFloat. */
-    public Number.mpfloat (MPFloat value)
+    public Number.float (float value)
     {
-        re_num = value;
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.set_unsigned_integer (0, Round.NEAREST);
-        im_num = tmp;
+        var z = new Number.integer (0);
+
+        if (value != 0)
+        {
+            /* CHECK SIGN */
+            var rj = 0f;
+            if (value < 0.0f)
+            {
+                z.re_sign = -1;
+                rj = -value;
+            }
+            else if (value > 0.0f)
+            {
+                z.re_sign = 1;
+                rj = value;
+            }
+
+            /* INCREASE IE AND DIVIDE RJ BY 16. */
+            var ie = 0;
+            while (rj >= 1.0f)
+            {
+                ie++;
+                rj *= 0.0625f;
+            }
+            while (rj < 0.0625f)
+            {
+                ie--;
+                rj *= 16.0f;
+            }
+
+            /*  NOW RJ IS DY DIVIDED BY SUITABLE POWER OF 16.
+             *  SET re_exponent TO 0
+             */
+            z.re_exponent = 0;
+
+            /* CONVERSION LOOP (ASSUME SINGLE-PRECISION OPS. EXACT) */
+            for (var i = 0; i < T + 4; i++)
+            {
+                rj *= BASE;
+                z.re_fraction[i] = (int) rj;
+                rj -= z.re_fraction[i];
+            }
+
+            /* NORMALIZE RESULT */
+            mp_normalize (ref z);
+
+            /* Computing MAX */
+            var ib = int.max (BASE * 7 * BASE, 32767) / 16;
+            var tp = 1;
+
+            /* NOW MULTIPLY BY 16**IE */
+            if (ie < 0)
+            {
+                var k = -ie;
+                for (var i = 1; i <= k; i++)
+                {
+                    tp <<= 4;
+                    if (tp <= ib && tp != BASE && i < k)
+                        continue;
+                    z = z.divide_integer (tp);
+                    tp = 1;
+                }
+            }
+            else if (ie > 0)
+            {
+                for (var i = 1; i <= ie; i++)
+                {
+                    tp <<= 4;
+                    if (tp <= ib && tp != BASE && i < ie)
+                        continue;
+                    z = z.multiply_integer (tp);
+                    tp = 1;
+                }
+            }
+        }
+
+        re_sign = z.re_sign;
+        im_sign = z.im_sign;
+        re_exponent = z.re_exponent;
+        im_exponent = z.im_exponent;
+        for (var i = 0; i < z.re_fraction.length; i++)
+        {
+            re_fraction[i] = z.re_fraction[i];
+            im_fraction[i] = z.im_fraction[i];
+        }
     }
 
     public Number.double (double value)
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.set_double (value, Round.NEAREST);
-        re_num = tmp;
-        var tmp2 = MPFloat.init2 ((Precision) precision);
-        tmp2.set_unsigned_integer (0, Round.NEAREST);
-        im_num = tmp2;
+        var z = new Number.integer (0);
+
+        if (value != 0)
+        {
+            /* CHECK SIGN */
+            var dj = 0.0;
+            if (value < 0.0)
+            {
+                z.re_sign = -1;
+                dj = -value;
+            }
+            else if (value > 0.0)
+            {
+                z.re_sign = 1;
+                dj = value;
+            }
+
+            /* INCREASE IE AND DIVIDE DJ BY 16. */
+            var ie = 0;
+            for (ie = 0; dj >= 1.0; ie++)
+                dj *= 1.0/16.0;
+
+            for ( ; dj < 1.0/16.0; ie--)
+                dj *= 16.0;
+
+            /*  NOW DJ IS DY DIVIDED BY SUITABLE POWER OF 16
+             *  SET re_exponent TO 0
+             */
+            z.re_exponent = 0;
+
+            /* CONVERSION LOOP (ASSUME DOUBLE-PRECISION OPS. EXACT) */
+            for (var i = 0; i < T + 4; i++)
+            {
+                dj *= (double) BASE;
+                z.re_fraction[i] = (int) dj;
+                dj -= (double) z.re_fraction[i];
+            }
+
+            /* NORMALIZE RESULT */
+            mp_normalize (ref z);
+
+            /* Computing MAX */
+            var ib = int.max (BASE * 7 * BASE, 32767) / 16;
+            var tp = 1;
+
+            /* NOW MULTIPLY BY 16**IE */
+            if (ie < 0)
+            {
+                var k = -ie;
+                for (var i = 1; i <= k; ++i)
+                {
+                    tp <<= 4;
+                    if (tp <= ib && tp != BASE && i < k)
+                        continue;
+                    z = z.divide_integer (tp);
+                    tp = 1;
+                }
+            }
+            else if (ie > 0)
+            {
+                for (var i = 1; i <= ie; ++i)
+                {
+                    tp <<= 4;
+                    if (tp <= ib && tp != BASE && i < ie)
+                        continue;
+                    z = z.multiply_integer (tp);
+                    tp = 1;
+                }
+            }
+        }
+
+        re_sign = z.re_sign;
+        im_sign = z.im_sign;
+        re_exponent = z.re_exponent;
+        im_exponent = z.im_exponent;
+        for (var i = 0; i < z.re_fraction.length; i++)
+        {
+            re_fraction[i] = z.re_fraction[i];
+            im_fraction[i] = z.im_fraction[i];
+        }
     }
 
     public Number.complex (Number x, Number y)
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.@set (x.re_num, Round.NEAREST);
-        re_num = tmp;
-        var tmp2 = MPFloat.init2 ((Precision) precision);
-        tmp2.@set (y.re_num, Round.NEAREST);
-        im_num = tmp2;
+        re_sign = x.re_sign;
+        re_exponent = x.re_exponent;
+        for (var i = 0; i < im_fraction.length; i++)
+            re_fraction[i] = x.re_fraction[i];
+
+        im_sign = y.re_sign;
+        im_exponent = y.re_exponent;
+        for (var i = 0; i < im_fraction.length; i++)
+            im_fraction[i] = y.re_fraction[i];
     }
 
     public Number.polar (Number r, Number theta, AngleUnit unit = AngleUnit.RADIANS)
@@ -125,35 +328,28 @@
 
     public Number.eulers ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        var tmp2 = MPFloat.init2 ((Precision) precision);
-        tmp2.set_unsigned_integer (1, Round.NEAREST);
-        /* e^1, since mpfr doesn't have a function to return e */
-        tmp.exp (tmp2, Round.NEAREST);
-        re_num = tmp;
-        var tmp3 = MPFloat.init2 ((Precision) precision);
-        tmp3.set_unsigned_integer (0, Round.NEAREST);
-        im_num = tmp3;
+        var z = new Number.integer (1).epowy ();
+        re_sign = z.re_sign;
+        im_sign = z.im_sign;
+        re_exponent = z.re_exponent;
+        im_exponent = z.im_exponent;
+        for (var i = 0; i < z.re_fraction.length; i++)
+        {
+            re_fraction[i] = z.re_fraction[i];
+            im_fraction[i] = z.im_fraction[i];
+        }
     }
 
     public Number.i ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        var tmp2 = MPFloat.init2 ((Precision) precision);
-        tmp.set_unsigned_integer (0, Round.NEAREST);
-        tmp2.set_unsigned_integer (1, Round.NEAREST);
-        re_num = tmp;
-        im_num = tmp2;
+        im_sign = 1;
+        im_exponent = 1;
+        im_fraction[0] = 1;
     }
 
     public Number.pi ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.const_pi (Round.NEAREST);
-        re_num = tmp;
-        var tmp2 = MPFloat.init2 ((Precision) precision);
-        tmp2.set_unsigned_integer (0, Round.NEAREST);
-        im_num = tmp2;
+        Number.double (Math.PI);
     }
 
     /* Sets z to be a uniform random number in the range [0, 1] */
@@ -162,42 +358,123 @@
         Number.double (Random.next_double ());
     }
 
-    ~Number ()
-    {
-        re_num.clear ();
-        im_num.clear ();
-    }
-
     public int64 to_integer ()
     {
-        return re_num.get_signed_integer (Round.NEAREST);
+        int64 z = 0;
+
+        /* |x| <= 1 */
+        if (re_sign == 0 || re_exponent <= 0)
+            return 0;
+
+        /* Multiply digits together */
+        for (var i = 0; i < re_exponent; i++)
+        {
+            var t = z;
+            z = z * BASE + re_fraction[i];
+
+            /* Check for overflow */
+            if (z <= t)
+                return 0;
+        }
+
+        /* Validate result */
+        var v = z;
+        for (var i = re_exponent - 1; i >= 0; i--)
+        {
+            /* Get last digit */
+            var digit = v - (v / BASE) * BASE;
+            if (re_fraction[i] != digit)
+                return 0;
+
+            v /= BASE;
+        }
+        if (v != 0)
+            return 0;
+
+        return re_sign * z;
     }
 
     public uint64 to_unsigned_integer ()
     {
-        return re_num.get_unsigned_integer (Round.NEAREST);
+        /* x <= 1 */
+        if (re_sign <= 0 || re_exponent <= 0)
+            return 0;
+
+        /* Multiply digits together */
+        uint64 z = 0;
+        for (var i = 0; i < re_exponent; i++)
+        {
+            var t = z;
+            z = z * BASE + re_fraction[i];
+
+            /* Check for overflow */
+            if (z <= t)
+                return 0;
+        }
+
+        /* Validate result */
+        var v = z;
+        for (var i = re_exponent - 1; i >= 0; i--)
+        {
+            /* Get last digit */
+            var digit = (uint64) v - (v / BASE) * BASE;
+            if (re_fraction[i] != digit)
+                return 0;
+
+            v /= BASE;
+        }
+        if (v != 0)
+            return 0;
+
+        return z;
     }
 
     public float to_float ()
     {
-        return re_num.get_float (Round.NEAREST);
+        if (is_zero ())
+            return 0f;
+
+        var z = 0f;
+        for (var i = 0; i < T; i++)
+        {
+            if (re_fraction[i] != 0)
+                z += re_fraction[i] * Math.powf (BASE, re_exponent - i - 1);
+        }
+
+        if (re_sign < 0)
+            return -z;
+        else
+            return z;
     }
 
     public double to_double ()
     {
-        return re_num.get_double (Round.NEAREST);
+        if (is_zero ())
+            return 0d;
+
+        var z = 0d;
+        for (var i = 0; i < T; i++)
+        {
+            if (re_fraction[i] != 0)
+                z += re_fraction[i] * Math.pow (BASE, re_exponent - i - 1);
+        }
+
+        if (re_sign < 0)
+            return -z;
+        else
+            return z;
     }
 
     /* Return true if the value is x == 0 */
     public bool is_zero ()
     {
-        return re_num.is_zero () && im_num.is_zero ();
+        return re_sign == 0 && im_sign == 0;
     }
 
     /* Return true if x < 0 */
     public bool is_negative ()
     {
-        return re_num.sgn () < 0;
+        return re_sign < 0;
     }
 
     /* Return true if x is integer */
@@ -205,8 +482,35 @@
     {
         if (is_complex ())
             return false;
+        /* Multiplication and division by 10000 is used to get around a
+         * limitation to the "fix" for Sun bugtraq bug #4006391 in the
+         * floor () routine in mp.c, when the re_exponent is less than 1.
+         */
+        var t3 = new Number.integer (10000);
+        var t1 = multiply (t3);
+        t1 = t1.divide (t3);
+        var t2 = t1.floor ();
+        return t1.equals (t2);
 
-        return re_num.is_integer () != 0;
+        /* Correct way to check for integer */
+        /*
+
+        // Zero is an integer
+        if (is_zero ())
+            return true;
+
+        // fractional
+        if (re_exponent <= 0)
+            return false;
+
+        // Look for fractional components
+        for (var i = re_exponent; i < SIZE; i++)
+        {
+            if (re_fraction[i] != 0)
+                return false;
+        }
+
+        return true;*/
     }
 
     /* Return true if x is a positive integer */
@@ -215,7 +519,7 @@
         if (is_complex ())
             return false;
         else
-            return re_num.sgn () >= 0 && is_integer ();
+            return re_sign >= 0 && is_integer ();
     }
 
     /* Return true if x is a natural number (an integer ≥ 0) */
@@ -224,34 +528,19 @@
         if (is_complex ())
             return false;
         else
-            return re_num.sgn () > 0 && is_integer ();
+            return re_sign > 0 && is_integer ();
     }
 
     /* Return true if x has an imaginary component */
     public bool is_complex ()
     {
-        return !im_num.is_zero ();
+        return im_sign != 0;
     }
 
-    /* Return error if overflow or underflow */
-    public static void check_flags ()
-    {
-        if (mpfr_is_underflow () != 0)
-        {
-            /* Translators: Error displayed when underflow error occured */
-            error = _("Underflow error");
-        }
-        else if (mpfr_is_overflow () != 0)
-        {
-            /* Translators: Error displayed when overflow error occured */
-            error = _("Overflow error");
-        }
-    }
-
     /* Return true if x == y */
     public bool equals (Number y)
     {
-        return re_num.is_equal (y.re_num);
+        return compare (y) == 0;
     }
 
     /* Returns:
@@ -261,25 +550,62 @@
      */
     public int compare (Number y)
     {
-        return re_num.cmp (y.re_num);
+        if (re_sign != y.re_sign)
+        {
+            if (re_sign > y.re_sign)
+                return 1;
+            else
+                return -1;
+        }
+
+        /* x = y = 0 */
+        if (is_zero ())
+            return 0;
+
+        /* See if numbers are of different magnitude */
+        if (re_exponent != y.re_exponent)
+        {
+            if (re_exponent > y.re_exponent)
+                return re_sign;
+            else
+                return -re_sign;
+        }
+
+        /* Compare fractions */
+        for (var i = 0; i < SIZE; i++)
+        {
+            if (re_fraction[i] == y.re_fraction[i])
+                continue;
+
+            if (re_fraction[i] > y.re_fraction[i])
+                return re_sign;
+            else
+                return -re_sign;
+        }
+
+        /* x = y */
+        return 0;
     }
 
     /* Sets z = sgn (x) */
     public Number sgn ()
     {
-        var z = new Number.integer (re_num.sgn ());
-        return z;
+        if (is_zero ())
+            return new Number.integer (0);
+        else if (is_negative ())
+            return new Number.integer (-1);
+        else
+            return new Number.integer (1);
     }
 
     /* Sets z = −x */
     public Number invert_sign ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.neg (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        var tmp_im = z.im_num;
-        tmp_im.neg (im_num, Round.NEAREST);
-        z.im_num = tmp_im;
+        var z = copy ();
+
+        z.re_sign = -z.re_sign;
+        z.im_sign = -z.im_sign;
+
         return z;
     }
 
@@ -294,13 +620,13 @@
             x_real = x_real.multiply (x_real);
             x_im = x_im.multiply (x_im);
             var z = x_real.add (x_im);
-            return z.sqrt ();
+            return z.root (2);
         }
         else
         {
-            var tmp = MPFloat.init2 ((Precision) precision);
-            tmp.abs (re_num, Round.NEAREST);
-            var z = new Number.mpfloat (tmp);
+            var z = copy ();
+            if (z.re_sign < 0)
+                z.re_sign = -z.re_sign;
             return z;
         }
     }
@@ -311,7 +637,7 @@
         if (is_zero ())
         {
             /* Translators: Error display when attempting to take argument of zero */
-            error = _("Argument not defined for zero");
+            mperr (_("Argument not defined for zero"));
             return new Number.integer (0);
         }
 
@@ -355,12 +681,8 @@
     /* Sets z = ‾̅x */
     public Number conjugate ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.neg (im_num, Round.NEAREST);
         var z = copy ();
-        var tmp2 = z.im_num;
-        tmp2.clear ();
-        z.im_num = tmp;
+        z.im_sign = -z.im_sign;
         return z;
     }
 
@@ -368,11 +690,13 @@
     public Number real_component ()
     {
         var z = copy ();
-        var tmp = z.im_num;
-        tmp.clear ();
-        tmp = MPFloat.init2 ((Precision) precision);
-        tmp.set_unsigned_integer (0, Round.NEAREST);
-        z.im_num = tmp;
+
+        /* Clear imaginary component */
+        z.im_sign = 0;
+        z.im_exponent = 0;
+        for (var i = 0; i < z.im_fraction.length; i++)
+            z.im_fraction[i] = 0;
+
         return z;
     }
 
@@ -380,30 +704,65 @@
     public Number imaginary_component ()
     {
         /* Copy imaginary component to real component */
-        var z = copy ();
-        var tmp = z.re_num;
-        tmp.clear ();
-        z.re_num = z.im_num;
-        tmp = MPFloat.init2 ((Precision) precision);
-        tmp.set_unsigned_integer (0, Round.NEAREST);
-        z.im_num = tmp;
+        var z = new Number ();
+        z.re_sign = im_sign;
+        z.re_exponent = im_exponent;
+
+        for (var i = 0; i < z.im_fraction.length; i++)
+            z.re_fraction[i] = im_fraction[i];
+
+        /* Clear (old) imaginary component */
+        z.im_sign = 0;
+        z.im_exponent = 0;
+        for (var i = 0; i < z.im_fraction.length; i++)
+            z.im_fraction[i] = 0;
+
         return z;
     }
 
     public Number integer_component ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.trunc (re_num);
-        var z = new Number.mpfloat (tmp);
+        /* Clear re_fraction */
+        var z = copy ();
+        for (var i = z.re_exponent; i < SIZE; i++)
+            z.re_fraction[i] = 0;
+        z.im_sign = 0;
+        z.im_exponent = 0;
+        for (var i = 0; i < z.im_fraction.length; i++)
+            z.im_fraction[i] = 0;
+
         return z;
+
     }
 
     /* Sets z = x mod 1 */
     public Number fractional_component ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.frac (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
+       /* fractional component of zero is 0 */
+        if (is_zero ())
+            return new Number.integer (0);
+
+        /* All fractional */
+        if (re_exponent <= 0)
+            return this;
+
+        /* Shift fractional component */
+        var shift = re_exponent;
+        for (var i = shift; i < SIZE && re_fraction[i] == 0; i++)
+            shift++;
+        var z = new Number.integer (0);
+        z.re_sign = re_sign;
+        z.re_exponent = re_exponent - shift;
+        for (var i = 0; i < SIZE; i++)
+        {
+            if (i + shift >= SIZE)
+                z.re_fraction[i] = 0;
+            else
+                z.re_fraction[i] = re_fraction[i + shift];
+        }
+        if (z.re_fraction[0] == 0)
+            z.re_sign = 0;
+
         return z;
     }
 
@@ -416,9 +775,36 @@
     /* Sets z = ⌊x⌋ */
     public Number floor ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.floor (re_num);
-        var z = new Number.mpfloat (tmp);
+        /* Integer component of zero = 0 */
+        if (is_zero ())
+            return this;
+
+        /* If all fractional then no integer component */
+        if (re_exponent <= 0)
+        {
+            if (is_negative ())
+                return new Number.integer (-1);
+            else
+                return new Number.integer (0);
+        }
+
+        /* Clear fractional component */
+        var z = copy ();
+        var have_fraction = false;
+        for (var i = z.re_exponent; i < SIZE; i++)
+        {
+            if (z.re_fraction[i] != 0)
+                have_fraction = true;
+            z.re_fraction[i] = 0;
+        }
+        z.im_sign = 0;
+        z.im_exponent = 0;
+        for (var i = 0; i < z.im_fraction.length; i++)
+            z.im_fraction[i] = 0;
+
+        if (have_fraction && is_negative ())
+            z = z.add (new Number.integer (-1));
+
         return z;
     }
 
@@ -425,19 +811,29 @@
     /* Sets z = ⌈x⌉ */
     public Number ceiling ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.ceil (re_num);
-        var z = new Number.mpfloat (tmp);
-        return z;
+        var z = floor ();
+        var f = fractional_component ();
+        if (f.is_zero ())
+            return z;
+        return z.add (new Number.integer (1));
     }
 
     /* Sets z = [x] */
     public Number round ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.round (re_num);
-        var z = new Number.mpfloat (tmp);
-        return z;
+        var do_floor = !is_negative ();
+
+        var f = fractional_component ();
+        f = f.multiply_integer (2);
+        f = f.abs ();
+        if (f.compare (new Number.integer (1)) >= 0)
+            do_floor = !do_floor;
+
+        if (do_floor)
+            return floor ();
+        else
+            return ceiling ();
+
     }
 
     /* Sets z = 1 ÷ x */
@@ -482,24 +878,10 @@
     /* Sets z = x^y */
     public Number xpowy (Number y)
     {
-        /* 0^-n invalid */
-        if (is_zero () && y.is_negative ())
+        if (y.is_integer ())
+            return xpowy_integer (y.to_integer ());
+        else
         {
-            /* Translators: Error displayed when attempted to raise 0 to a negative re_exponent */
-            error = _("The power of zero is undefined for a negative exponent");
-            return new Number.integer (0);
-        }
-
-        /* 0^0 is indeterminate */
-        if (is_zero () && y.is_zero ())
-        {
-            /* Translators: Error displayed when attempted to raise 0 to power of zero */
-            error = _("Zero raised to zero is undefined");
-            return new Number.integer (0);
-        }
-
-        if (!y.is_integer ())
-        {
             var reciprocal = y.reciprocal ();
             if (reciprocal.is_integer ())
                 return root (reciprocal.to_integer ());
@@ -506,29 +888,6 @@
             else
                 return pwr (y);
         }
-
-        Number t;
-        Number t2;
-        if (y.is_negative ())
-        {
-            t = reciprocal ();
-            t2 = y.invert_sign ();
-        }
-        else
-        {
-            t = this;
-            t2 = y;
-        }
-
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.power (t.re_num, t2.re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        var tmp2 = z.im_num;
-        tmp2.clear ();
-        tmp = MPFloat.init2 ((Precision) precision);
-        tmp.@set (t.im_num, Round.NEAREST);
-        z.im_num = tmp;
-        return z;
     }
 
     /* Sets z = x^y */
@@ -538,7 +897,7 @@
         if (is_zero () && n < 0)
         {
             /* Translators: Error displayed when attempted to raise 0 to a negative re_exponent */
-            error = _("The power of zero is undefined for a negative exponent");
+            mperr (_("The power of zero is undefined for a negative exponent"));
             return new Number.integer (0);
         }
 
@@ -546,10 +905,22 @@
         if (is_zero () && n == 0)
         {
             /* Translators: Error displayed when attempted to raise 0 to power of zero */
-            error = _("Zero raised to zero is undefined");
+            mperr (_("Zero raised to zero is undefined"));
             return new Number.integer (0);
         }
 
+        /* x^0 = 1 */
+        if (n == 0)
+            return new Number.integer (1);
+
+        /* 0^n = 0 */
+        if (is_zero ())
+            return new Number.integer (0);
+
+        /* x^1 = x */
+        if (n == 1)
+            return this;
+
         Number t;
         if (n < 0)
         {
@@ -557,44 +928,17 @@
             n = -n;
         }
         else
-        {
             t = this;
-        }
 
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.power_signed_integer (t.re_num, (long) n, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        var tmp2 = z.im_num;
-        tmp2.clear ();
-        tmp = MPFloat.init2 ((Precision) precision);
-        tmp.@set (t.im_num, Round.NEAREST);
-        z.im_num = tmp;
-        return z;
-    }
-
-    private Number pwr (Number y)
-    {
-        /* (-x)^y imaginary */
-        /* FIXME: Make complex numbers optional */
-        /*if (re_sign < 0)
+        var z = new Number.integer (1);
+        while (n != 0)
         {
-            mperr (_("The power of negative numbers is only defined for integer exponents"));
-            return new Number.integer (0);
-        }*/
-
-        /* 0^y = 0, 0^-y undefined */
-        if (is_zero ())
-        {
-            if (y.is_negative ())
-                error = _("The power of zero is undefined for a negative exponent");
-            return new Number.integer (0);
+            if (n % 2 == 1)
+                z = z.multiply (t);
+            t = t.multiply (t);
+            n = n / 2;
         }
-
-        /* x^0 = 1 */
-        if (y.is_zero ())
-            return new Number.integer (1);
-
-        return y.multiply (ln ()).epowy ();
+        return z;
     }
 
     /* Sets z = n√x */
@@ -623,10 +967,22 @@
     /* Sets z = √x */
     public Number sqrt ()
     {
-        var tmp = MPFloat.init2 ((Precision) precision);
-        tmp.sqrt (re_num, Round.NEAREST);
-        var z = new Number.mpfloat (tmp);
-        return z;
+        if (is_zero ())
+            return this;
+
+        /* FIXME: Make complex numbers optional */
+        /*if (re_sign < 0)
+        {
+            mperr (_("Square root is undefined for negative values"));
+            return new Number.integer (0);
+        }*/
+        else
+        {
+            var t = root (-2);
+            var z = multiply (t);
+            return z.ext (t.re_fraction[0], z.re_fraction[0]);
+        }
+
     }
 
     /* Sets z = ln x */
@@ -636,7 +992,7 @@
         if (is_zero ())
         {
             /* Translators: Error displayed when attempting to take logarithm of zero */
-            error = _("Logarithm of zero is undefined");
+            mperr (_("Logarithm of zero is undefined"));
             return new Number.integer (0);
         }
 
@@ -669,7 +1025,7 @@
         if (is_zero ())
         {
             /* Translators: Error displayed when attempting to take logarithm of zero */
-            error = _("Logarithm of zero is undefined");
+            mperr (_("Logarithm of zero is undefined"));
             return new Number.integer (0);
         }
 
@@ -691,17 +1047,17 @@
             if (is_negative () || is_complex ())
             {
                 /* Translators: Error displayed when attempted take the factorial of a negative or complex number */
-                error = _("Factorial is only defined for non-negative real numbers");
+                mperr (_("Factorial is only defined for non-negative real numbers"));
                 return new Number.integer (0);
             }
 
-            var tmp = add (new Number.integer (1));
-            var tmp2 = MPFloat.init2 ((Precision) precision);
+	    var val = to_double ();
 
             /* Factorial(x) = Gamma(x+1) - This is the formula used to calculate Factorial.*/
-            tmp2.gamma (tmp.re_num, Round.NEAREST);
+            var fact = Math.tgamma(val+1);
 
-            return new Number.mpfloat (tmp2);
+            return new Number.double(fact);
+
         }
 
         /* Convert to integer - if couldn't be converted then the factorial would be too big anyway */
